
####### Expanded from @PACKAGE_INIT@ by configure_package_config_file() #######
####### Any changes to this file will be overwritten by the next CMake run ####
####### The input file was hcc-config.cmake.in                            ########

get_filename_component(PACKAGE_PREFIX_DIR "${CMAKE_CURRENT_LIST_DIR}/../../../" ABSOLUTE)

macro(set_and_check _var _file)
  set(${_var} "${_file}")
  if(NOT EXISTS "${_file}")
    message(FATAL_ERROR "File or directory ${_file} referenced by variable ${_var} does not exist !")
  endif()
endmacro()

macro(check_required_components _NAME)
  foreach(comp ${${_NAME}_FIND_COMPONENTS})
    if(NOT ${_NAME}_${comp}_FOUND)
      if(${_NAME}_FIND_REQUIRED_${comp})
        set(${_NAME}_FOUND FALSE)
      endif()
    endif()
  endforeach()
endmacro()

####################################################################################

set_and_check( hcc_INCLUDE_DIR "/usr/include/hcc" )
set_and_check( hcc_INCLUDE_DIRS "${hcc_INCLUDE_DIR}" )
set_and_check( hcc_LIB_INSTALL_DIR "${PACKAGE_PREFIX_DIR}/lib64" )

find_path(HSA_HEADER hsa/hsa.h
  PATHS
    /usr/include/
)

find_library(HSA_LIBRARY hsa-runtime64
  PATHS
    /usr/lib64/
)

add_library(hsa-runtime64 SHARED IMPORTED GLOBAL)

set_target_properties(hsa-runtime64 PROPERTIES
  INTERFACE_INCLUDE_DIRECTORIES "${HSA_HEADER}"
  IMPORTED_LOCATION "${HSA_LIBRARY}"
  INTERFACE_SYSTEM_INCLUDE_DIRECTORIES "${HSA_HEADER}"
)

include( "${CMAKE_CURRENT_LIST_DIR}/ImportedTargets.cmake" )
include( "${CMAKE_CURRENT_LIST_DIR}/hcc-targets.cmake" )

set( hcc_LIBRARIES hcc::hccrt hcc::hc_am)
set( hcc_LIBRARY ${hcc_LIBRARIES})

set(HCC_INCLUDE_DIR ${hcc_INCLUDE_DIR})
set(HCC_INCLUDE_DIRS ${hcc_INCLUDE_DIRS})
set(HCC_LIB_INSTALL_DIR ${hcc_LIB_INSTALL_DIR})
set(HCC_LIBRARIES ${hcc_LIBRARIES})
set(HCC_LIBRARY ${hcc_LIBRARY})
